﻿using System;
using System.Collections.Generic;
using System.Text;
using Indlæsning;

namespace StatePattern {
    class EfterFødselsårTilstand : State {
        private static EfterFødselsårTilstand instans = new EfterFødselsårTilstand();
        private EfterFødselsårTilstand() { }
        public static EfterFødselsårTilstand Instans {get{return instans;}}
        public override State ProcessEvent() {
            State state = null;
            switch (Brik.Instans.Type) {
                case (int)MedlemslisteAnalysator.Briktype.Junior:
                case (int)MedlemslisteAnalysator.Briktype.Senior:
                    state = EfterKategoriTilstand.Instans;
                    if (!state.Enter())
                        return Fejltilstand.Instans;
                    break;
                case (int)MedlemslisteAnalysator.Briktype.Semikolon:
                    state = EfterSemikolonTilstand.Instans;
                    if (!state.Enter())
                        return Fejltilstand.Instans;
                    break;
                case (int)MedlemslisteAnalysator.Briktype.Navn:
                case (int)MedlemslisteAnalysator.Briktype.Fødselsår:
                case (int)MedlemslisteAnalysator.Briktype.Slut:
                case (int)MedlemslisteAnalysator.Briktype.Andet:
                    state = Fejltilstand.Instans;
                    ((Fejltilstand)state).Enter(string.Format("Fejl i '{0}'. Kategori eller semikolon forventet!", Brik.Instans.Leksem));
                    break;
            }
            return state;
        }
        public override bool Enter() {
            // Semantik: Gem fødselsår
            Medlem.Instans.Fødselsår = int.Parse(Brik.Instans.Leksem);
            return true;
        }
    }
}
