using System;
using System.Collections.Generic;
using System.Text;
using Indlsning;

namespace StatePattern {
    class EfterKategoriTilstand : State {
        private static EfterKategoriTilstand instans = new EfterKategoriTilstand();
        private const int SENIOR_ALDER = 18;
        private EfterKategoriTilstand() { }
        public static EfterKategoriTilstand Instans {get{return instans;}}
        public override State ProcessEvent() {
            State state = null;
            switch (Brik.Instans.Type) {
                case (int)MedlemslisteAnalysator.Briktype.Semikolon:
                    state = EfterSemikolonTilstand.Instans;
                    if (!state.Enter())
                        return Fejltilstand.Instans;
                    break;
                case (int)MedlemslisteAnalysator.Briktype.Navn:
                case (int)MedlemslisteAnalysator.Briktype.Fdselsr:
                case (int)MedlemslisteAnalysator.Briktype.Junior:
                case (int)MedlemslisteAnalysator.Briktype.Senior:
                case (int)MedlemslisteAnalysator.Briktype.Slut:
                case (int)MedlemslisteAnalysator.Briktype.Andet:
                    state = Fejltilstand.Instans;
                    ((Fejltilstand)state).Enter(string.Format("Fejl i '{0}'. Semikolon forventet!", Brik.Instans.Leksem));
                    break;
            }
            return state;
        }
        public override bool Enter() {
            // Semantik: Check kategori
            int alder = DateTime.Now.Year - Medlem.Instans.Fdselsr;
            if ((Brik.Instans.Type == (int)MedlemslisteAnalysator.Briktype.Junior && alder < SENIOR_ALDER) ||
                (Brik.Instans.Type == (int)MedlemslisteAnalysator.Briktype.Senior && alder >= SENIOR_ALDER))
                Medlem.Instans.Kategori = Brik.Instans.Leksem;
            else {
                Fejltilstand.Instans.Enter(string.Format("Fejl i '{0}'. Fdselsr og kategori stemmer ikke overens!", Brik.Instans.Leksem));
                return false;
            }
            return true;
        }
    }
}
